/**
 * Ex. 1: write a PROMELA model that sums even elements and subtracts odd elements in an
 * array of integers.
 * - declare and (non-deterministically) initialize an integer array with values in [0, 9].
 * - add a loop that sums even elements and subtracts odd elements.
 * - visually check that it is correct.
 * - Q: why is it not possible to initialize the array with any random integer value?
 */

byte array[10];

/* non-deterministically (randomly) initialize
 * the array location of index i
 */
inline randinit(i) {
	byte c;	/* necessary to ensure progress! */
	do
		/* probability 0.9 of increasing the value */
		:: c < 255 ->		/* #1 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #2 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #3 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #4 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #5 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #6 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #7 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #8 */
			array[i]++;
			c++;
		:: c < 255 ->		/* #9 */
			array[i]++;
			c++;
		/* probability 0.1 of exiting the loop */
		:: true -> break;
	od;
	printf("\tarray[%d] = %d\n", i, array[i]);
}

init {
	int sum = 0;
	byte i = 0;

	/* random initialization */
	printf("loading..\n");
	do
		:: i < 10 ->
			randinit(i);
			i++;
		:: else ->
			break;
	od;

	/* sum */
	printf("thinking..\n");
	i = 0;
	do
		:: i < 10 ->
			if
				:: i % 2 == 0 ->
					sum = sum + array[i];
				:: i % 2 == 1 ->
					sum = sum - array[i];
			fi;
			i++;
		:: else ->
			break;
	od;

	printf("result: %d\n", sum);
}
