/**
 * Ex. 3: replace the synchronous channel with a buffered channel and
 * check how the behaviour changes;
 */

chan mqueue = [10] of { byte };

active proctype A() {
	byte x = 'a';
	do
		:: x <= 'z' ->
			atomic {
				printf("A: sending %c\n", x);
				mqueue!x;
			}
			x++;
		:: else ->
			break;
	od
	printf("A: terminated.\n");
}

active proctype B() {
	byte y;
	do
		:: atomic {
			mqueue?y ->
				printf("B: received %c\n", y);
			}
		:: y >= 'z' ->
			break;
	od;
	assert(y == 'z');
	printf("B: terminated.\n");
}
